function varargout = beam_bending_transmissibility(varargin)
% BEAM_BENDING_TRANSMISSIBILITY MATLAB code for beam_bending_transmissibility.fig
%      BEAM_BENDING_TRANSMISSIBILITY, by itself, creates a new BEAM_BENDING_TRANSMISSIBILITY or raises the existing
%      singleton*.
%
%      H = BEAM_BENDING_TRANSMISSIBILITY returns the handle to a new BEAM_BENDING_TRANSMISSIBILITY or the handle to
%      the existing singleton*.
%
%      BEAM_BENDING_TRANSMISSIBILITY('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BEAM_BENDING_TRANSMISSIBILITY.M with the given input arguments.
%
%      BEAM_BENDING_TRANSMISSIBILITY('Property','Value',...) creates a new BEAM_BENDING_TRANSMISSIBILITY or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before beam_bending_transmissibility_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to beam_bending_transmissibility_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help beam_bending_transmissibility

% Last Modified by GUIDE v2.5 04-Feb-2013 15:40:04

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @beam_bending_transmissibility_OpeningFcn, ...
                   'gui_OutputFcn',  @beam_bending_transmissibility_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before beam_bending_transmissibility is made visible.
function beam_bending_transmissibility_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to beam_bending_transmissibility (see VARARGIN)

% Choose default command line output for beam_bending_transmissibility
handles.output = hObject;

iu=getappdata(0,'unit');
L=getappdata(0,'length');

if(iu==1)
    set(handles.length_unit,'String','inch');
    LS=sprintf('Beam Length = %8.4g inch',L);
else
    set(handles.length_unit,'String','meters');
    LS=sprintf('Beam Length = %8.4g meters',L);
end

set(handles.beam_length,'String',LS);

    
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes beam_bending_transmissibility wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = beam_bending_transmissibility_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in Calculate_pushbutton.
function Calculate_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to Calculate_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

  fig_num=getappdata(0,'fig_num');
      damp=getappdata(0,'damping');
        fn=getappdata(0,'fn');
      iu=getappdata(0,'unit');
      Q=getappdata(0,'Q');
      part=getappdata(0,'part');
 
      beta=getappdata(0,'beta');
      
      LBC=getappdata(0,'LBC');
      RBC=getappdata(0,'RBC');
      
      fstart=str2num(get(handles.fstart_edit,'String'));
      fend=str2num(get(handles.fend_edit,'String'));
      x=str2num(get(handles.x_edit,'String')); 
      
      sq_mass=getappdata(0,'sq_mass');
      beta=getappdata(0,'beta');
      C=getappdata(0,'C');
      
 
    [ModeShape,ModeShape_dd]=beam_bending_modes_shapes(LBC,RBC);

                   

     clear f;
   nf=1000;
   n=length(fn);
%
   disp(' ');
   fmax=fend;
%
   f=zeros(nf,1);
   f(1)=fstart;
   for k=2:nf
        f(k)=f(k-1)*2^(1/48);
        if(f(k)>fmax)
            break;
        end    
   end
   nf=max(size(f));
   YY=zeros(n,1);
   for i=1:n
        arg=beta(i)*x;
        YY(i)=ModeShape(arg,C(i),sq_mass);
   end
%
   H=zeros(nf,1);
   H_relA=zeros(nf,1);
   for k=1:nf 
        H(k)=0;
        HrelA(k)=0;
        om=2*pi*f(k);
        for i=1:n
            pY=part(i)*YY(i);
            omn=2*pi*fn(i);
            num=-pY;
            den=(omn^2-om^2)+(1i)*2*damp(i)*om*omn;
            H(k)=H(k)+num/den;
%
        end
        H_relA(k)=-om^2*H(k);
   end
%
    H=abs(H);
    HA=abs(H_relA+1);   
%
    if(iu==1)
        H=H*386;
    else
        H=H*9.81;       
    end
%
    maxH=0.;
    maxHA=0.;
    maxF=0.;
    maxFA=0.;
%
    out1=sprintf('\n nf=%d \n',nf);
    disp(out1);   
%
    for k=1:nf
        if(H(k)>maxH)
            maxH=H(k);
            maxF=f(k);
        end
        if(HA(k)>maxHA)
            maxHA=HA(k);
            maxFA=f(k);
        end
    end       
%
    sz=size(f);
    if(sz(2)>sz(1))
        f=f';
    end
    sz=size(H);
    if(sz(2)>sz(1))
        H=H';
    end 
    sz=size(HA);
    if(sz(2)>sz(1))
        HA=HA';
    end 
%
    n=length(f);
    for i=n:-1:1
%
       if(f(i)==0)
            f(i)=[];
            H(i)=[];
           HA(i)=[];
       H_relA(i)=[];  
       end
%
    end
%%%
    if(iu==1)
        out1=sprintf('\n Response Location: x=%8.4g inches\n',x);
    else
        out1=sprintf('\n Response Location:x=%8.4g meters \n',x);        
    end
    disp(out1); 
%%%
    figure(fig_num);
    fig_num=fig_num+1;
    plot(f,H);
    set(gca,'MinorGridLineStyle','none','GridLineStyle',':','XScale','log','YScale','log');
%
    if(iu==1)
        out1=sprintf('Frequency Response Function  x=%7.4g inch',x);
        ylabel('Rel Disp (in)/ Base Accel (G)');
    else
        out1=sprintf('Frequency Response Function  x=%7.4g m',x);
        ylabel('Rel Disp (m)/ Base Accel (G)');        
    end
%
%
    title(out1);
    xlabel('Frequency (Hz)');
    set(gca,'FontSize',12);
    h = get(gca, 'xlabel');
    set(h, 'FontName', 'Arial','FontSize',12);
    h = get(gca, 'ylabel');
    set(h, 'FontName', 'Arial','FontSize',12); 
    h = get(gca, 'title');
    set(h, 'FontName', 'Arial','FontSize',12);
    grid on;
    disp(' ');
    if(iu==1)
        out1=sprintf('  max Rel Disp FRF = %9.5f (in/G) at %8.4g Hz ',maxH,maxF);
    else
        out1=sprintf('  max Rel Disp FRF = %9.5f (m/G) at %8.4g Hz ',maxH,maxF);       
    end
    disp(out1);
%
    clear relative_disp;
    relative_disp=[f H];
%
    figure(fig_num);
    fig_num=fig_num+1;
    plot(f,HA);
    set(gca,'MinorGridLineStyle','none','GridLineStyle',':','XScale','log','YScale','log');
%    
    if(iu==1)
        out1=sprintf('Frequency Response Function  x=%7.4g inch',x);
    else
        out1=sprintf('Frequency Response Function  x=%7.4g m',x);        
    end
%    
    title(out1);
    ymax= 10^(ceil(log10(max(abs(HA)))+0.1));
    ymin= 10^(floor(log10(min(abs(HA)))-0.1));
%
    LL=ymax/10000;
%
    if(ymin<LL)
        ymin=LL;
    end
%
    axis([min(xlim),max(xlim),ymin,ymax]);
    ylabel('Absolute Accel / Base Accel ');
    xlabel('Frequency (Hz)');
    set(gca,'FontSize',12);
    h = get(gca, 'xlabel');
    set(h, 'FontName', 'Arial','FontSize',12);
    h = get(gca, 'ylabel');
    set(h, 'FontName', 'Arial','FontSize',12); 
    h = get(gca, 'title');
    set(h, 'FontName', 'Arial','FontSize',12);
    grid on;
    disp(' ');
    out1=sprintf('  max Absolute Accel FRF = %8.4g (G/G) at %8.4g Hz ',maxHA,maxFA);
    disp(out1);
%
    clear absolute_accel;
    absolute_accel=[f HA];
%

    setappdata(0,'fig_num',fig_num);
    
    msgbox('Calculation complete.  Output written to Matlab Command Window.');

%

      
      

% --- Executes on button press in Return_pushbutton.
function Return_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to Return_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close(beam_bending_transmissibility)


function fstart_edit_Callback(hObject, eventdata, handles)
% hObject    handle to fstart_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of fstart_edit as text
%        str2double(get(hObject,'String')) returns contents of fstart_edit as a double


% --- Executes during object creation, after setting all properties.
function fstart_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fstart_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function fend_edit_Callback(hObject, eventdata, handles)
% hObject    handle to fend_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of fend_edit as text
%        str2double(get(hObject,'String')) returns contents of fend_edit as a double


% --- Executes during object creation, after setting all properties.
function fend_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fend_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function x_edit_Callback(hObject, eventdata, handles)
% hObject    handle to x_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of x_edit as text
%        str2double(get(hObject,'String')) returns contents of x_edit as a double


% --- Executes during object creation, after setting all properties.
function x_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to x_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
